#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <math.h>

FILE *src, *dest, *bin;





void main( int _argc, char *_argv[] ) {
   int THRESH = 3952;  ///!!!
   printf("\nĿ");
   printf("\n Wav -> Txt                                 ");
   printf("\n");
   if (_argc != 4 ) {
     printf("\n\n Usage:\n mikro <source> <destination> <THRESH>\n\n");
     exit(1);
   };
   if (_argc == 4) {
     if ((src = fopen(_argv[1], "rb")) == NULL) {
       fprintf(stderr, "Cannot open source file.\n");
       exit(1);
     };
     if ((dest = fopen(_argv[2], "wt")) == NULL) {
       fprintf(stderr, "Cannot open destination file.\n");
       exit(1);
     };
     sscanf(_argv[3],"%i",&THRESH);
     printf("THRESH = %i",THRESH);
     if (THRESH<=0) THRESH = 3952;
     if ((bin = fopen("mikro.bin", "wb")) == NULL) {
       fprintf(stderr, "Cannot open bin file.\n");
       exit(1);
     };
   };

  int i = 0;
  int chr;
  for (i=0;i<=30;i++)
    chr = fgetc(src);   // dont read header and 2 first bytes

  int cnt = 1;
  int umax = chr; //!!
  int umin = chr; //!!
  int ph = (chr >= 128);
  int A,B,C,oldC=0,D,E,F,oldF=0,G,oldG=-1;
  int mode=0; // no E6 yet
  char curbyte = 0;
  int bitcnt = 0;
  int bytecnt = 0;
  int curb;
  while (!feof(src)) {
     int ph1 = (chr = fgetc(src)) >= 128;
     if (ph1 != ph) {
       {
        A = (ph?umax:umin);
        B = cnt;
//        fprintf(dest,"%i,%i\n",A,B);
        C = (abs(A-128)*B > THRESH) ? 1 : 0;       /// !!
//        fprintf(dest,"%i,%i,   %i\n",A,B,C);
        F = (oldF == C) ? 0 : 1;
        G = (C==1 || oldC!=0 || oldG==-1) ? F : -1;
//        printf ("\n%4i; %2i;  %3i,%3i,%1i,,,%1i,%1i",curbyte,bitcnt,A,B,C,F,G);
        if (G!=-1) {
          bitcnt++;
          curbyte = (curbyte << 1) + G;
          curb = curbyte;                          //
//          fprintf(dest,"=,=,%i,%X,%i\n",G,curbyte,bitcnt);   //
          if ( (curbyte == 230 || curbyte == 25) && mode == 0) {
//            fprintf(dest,"-----------------");   //
            mode = 1;
            bitcnt = 0;
            if (curbyte != 230) F = 1-F;
          }
          else if ( mode != 0 && bitcnt == 8 ) {
            curb = curbyte;
            fprintf(dest,"%i: %c, %i, %X\n",bytecnt, curbyte, curb, curb);
//            printf("-----------%i: %c, %i, %X\n",bytecnt, curbyte, curb, curb);
            fputc(curbyte,bin);
            bitcnt = 0;
            bytecnt++;
          };
        };
        oldC = C;
        oldF = F;
        oldG = G;
       };
       cnt = 1;
       umax = chr; //!!
       umin = chr; //!!
       ph = (chr >= 128);
     } else {
       cnt++;
       umax = (umax<=chr)?chr:umax;
       umin = (umin>=chr)?chr:umin;
     };
  };

  fclose(src);
  fclose(dest);
  fclose(bin);


}

